// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package drinks

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// DrinksClient is the client API for Drinks service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DrinksClient interface {
	// GetUser returns all information the API holds for the given user
	GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*GetUserResponse, error)
	// UpdateUser updates the user with the provided information or creates the user if it does not exist
	UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*UpdateUserResponse, error)
	// DeleteUser deletes the user specified by the choice of an identifier
	DeleteUser(ctx context.Context, in *DeleteUserRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListUsers returns a list of all users registered in the system
	ListUsers(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListUsersResponse, error)
	// GetUserStatus returns remaining credits of the given rfid
	GetUserStatus(ctx context.Context, in *GetUserStatusRequest, opts ...grpc.CallOption) (*GetUserStatusResponse, error)
	// DispenseCoffee returns remaining credits of the given rfid and saves the dispense in the database
	DispenseCoffee(ctx context.Context, in *DispenseCoffeeRequest, opts ...grpc.CallOption) (*DispenseCoffeeResponse, error)
	// DispenseBeer returns remaining credits of the given rfid and saves the dispense in the database
	DispenseBeer(ctx context.Context, in *DispenseBeerRequest, opts ...grpc.CallOption) (*DispenseBeerResponse, error)
}

type drinksClient struct {
	cc grpc.ClientConnInterface
}

func NewDrinksClient(cc grpc.ClientConnInterface) DrinksClient {
	return &drinksClient{cc}
}

func (c *drinksClient) GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*GetUserResponse, error) {
	out := new(GetUserResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/GetUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) UpdateUser(ctx context.Context, in *UpdateUserRequest, opts ...grpc.CallOption) (*UpdateUserResponse, error) {
	out := new(UpdateUserResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/UpdateUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) DeleteUser(ctx context.Context, in *DeleteUserRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/DeleteUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) ListUsers(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListUsersResponse, error) {
	out := new(ListUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/ListUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) GetUserStatus(ctx context.Context, in *GetUserStatusRequest, opts ...grpc.CallOption) (*GetUserStatusResponse, error) {
	out := new(GetUserStatusResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/GetUserStatus", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) DispenseCoffee(ctx context.Context, in *DispenseCoffeeRequest, opts ...grpc.CallOption) (*DispenseCoffeeResponse, error) {
	out := new(DispenseCoffeeResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/DispenseCoffee", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *drinksClient) DispenseBeer(ctx context.Context, in *DispenseBeerRequest, opts ...grpc.CallOption) (*DispenseBeerResponse, error) {
	out := new(DispenseBeerResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.drinks.Drinks/DispenseBeer", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DrinksServer is the server API for Drinks service.
// All implementations must embed UnimplementedDrinksServer
// for forward compatibility
type DrinksServer interface {
	// GetUser returns all information the API holds for the given user
	GetUser(context.Context, *GetUserRequest) (*GetUserResponse, error)
	// UpdateUser updates the user with the provided information or creates the user if it does not exist
	UpdateUser(context.Context, *UpdateUserRequest) (*UpdateUserResponse, error)
	// DeleteUser deletes the user specified by the choice of an identifier
	DeleteUser(context.Context, *DeleteUserRequest) (*emptypb.Empty, error)
	// ListUsers returns a list of all users registered in the system
	ListUsers(context.Context, *emptypb.Empty) (*ListUsersResponse, error)
	// GetUserStatus returns remaining credits of the given rfid
	GetUserStatus(context.Context, *GetUserStatusRequest) (*GetUserStatusResponse, error)
	// DispenseCoffee returns remaining credits of the given rfid and saves the dispense in the database
	DispenseCoffee(context.Context, *DispenseCoffeeRequest) (*DispenseCoffeeResponse, error)
	// DispenseBeer returns remaining credits of the given rfid and saves the dispense in the database
	DispenseBeer(context.Context, *DispenseBeerRequest) (*DispenseBeerResponse, error)
	mustEmbedUnimplementedDrinksServer()
}

// UnimplementedDrinksServer must be embedded to have forward compatible implementations.
type UnimplementedDrinksServer struct {
}

func (UnimplementedDrinksServer) GetUser(context.Context, *GetUserRequest) (*GetUserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUser not implemented")
}
func (UnimplementedDrinksServer) UpdateUser(context.Context, *UpdateUserRequest) (*UpdateUserResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateUser not implemented")
}
func (UnimplementedDrinksServer) DeleteUser(context.Context, *DeleteUserRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteUser not implemented")
}
func (UnimplementedDrinksServer) ListUsers(context.Context, *emptypb.Empty) (*ListUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListUsers not implemented")
}
func (UnimplementedDrinksServer) GetUserStatus(context.Context, *GetUserStatusRequest) (*GetUserStatusResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserStatus not implemented")
}
func (UnimplementedDrinksServer) DispenseCoffee(context.Context, *DispenseCoffeeRequest) (*DispenseCoffeeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DispenseCoffee not implemented")
}
func (UnimplementedDrinksServer) DispenseBeer(context.Context, *DispenseBeerRequest) (*DispenseBeerResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DispenseBeer not implemented")
}
func (UnimplementedDrinksServer) mustEmbedUnimplementedDrinksServer() {}

// UnsafeDrinksServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DrinksServer will
// result in compilation errors.
type UnsafeDrinksServer interface {
	mustEmbedUnimplementedDrinksServer()
}

func RegisterDrinksServer(s grpc.ServiceRegistrar, srv DrinksServer) {
	s.RegisterService(&Drinks_ServiceDesc, srv)
}

func _Drinks_GetUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).GetUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/GetUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).GetUser(ctx, req.(*GetUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_UpdateUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).UpdateUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/UpdateUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).UpdateUser(ctx, req.(*UpdateUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_DeleteUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).DeleteUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/DeleteUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).DeleteUser(ctx, req.(*DeleteUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_ListUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).ListUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/ListUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).ListUsers(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_GetUserStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserStatusRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).GetUserStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/GetUserStatus",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).GetUserStatus(ctx, req.(*GetUserStatusRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_DispenseCoffee_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DispenseCoffeeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).DispenseCoffee(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/DispenseCoffee",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).DispenseCoffee(ctx, req.(*DispenseCoffeeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Drinks_DispenseBeer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DispenseBeerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrinksServer).DispenseBeer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.drinks.Drinks/DispenseBeer",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrinksServer).DispenseBeer(ctx, req.(*DispenseBeerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Drinks_ServiceDesc is the grpc.ServiceDesc for Drinks service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Drinks_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.drinks.Drinks",
	HandlerType: (*DrinksServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetUser",
			Handler:    _Drinks_GetUser_Handler,
		},
		{
			MethodName: "UpdateUser",
			Handler:    _Drinks_UpdateUser_Handler,
		},
		{
			MethodName: "DeleteUser",
			Handler:    _Drinks_DeleteUser_Handler,
		},
		{
			MethodName: "ListUsers",
			Handler:    _Drinks_ListUsers_Handler,
		},
		{
			MethodName: "GetUserStatus",
			Handler:    _Drinks_GetUserStatus_Handler,
		},
		{
			MethodName: "DispenseCoffee",
			Handler:    _Drinks_DispenseCoffee_Handler,
		},
		{
			MethodName: "DispenseBeer",
			Handler:    _Drinks_DispenseBeer_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/vis/drinks/drinks.proto",
}
